﻿Imports System.IO
Public Class Animator
    Event MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
    Event MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
    Event MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
    Event KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs)
    Event Index(ByVal sender As Object, ByVal Status As Boolean)

    Private Sub PictureBox1_MouseDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseDoubleClick
        ContextMenuStrip1.Show(MousePosition)
    End Sub

    Private Sub PictureBox1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseDown
        RaiseEvent MouseDown(Me, e)
    End Sub

    Private Sub PictureBox1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseMove
        RaiseEvent MouseMove(Me, e)
    End Sub

    Private Sub PictureBox1_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseUp
        RaiseEvent MouseUp(Me, e)
    End Sub

    Property Start() As Boolean
        Get
            Return Timer1.Enabled
        End Get
        Set(ByVal value As Boolean)
            Timer1.Enabled = value
        End Set
    End Property

    Property Refresh_Time() As Integer
        Get
            Return Timer1.Interval
        End Get
        Set(ByVal value As Integer)
            Timer1.Interval = value
        End Set
    End Property

    Property Image_index() As Integer
        Get
            Return image_index_val
        End Get
        Set(ByVal value As Integer)
            image_index_val = value
            If image_arr.Count - 1 >= image_index_val Then
                If image_index_val < 0 Then image_index_val = 0
            Else
                image_index_val = 0
            End If
            image_get_index()
            RaiseEvent Index(Me, image_index_val)
        End Set
    End Property

    Property LoadSettings() As String
        Get
            Return LastLoadPath
        End Get
        Set(ByVal value As String)
            Load_Settings(value)
        End Set
    End Property

    Private Sub AddimageToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddimageToolStripMenuItem.Click
        Dim opn As New OpenFileDialog
        opn.Filter = "Image files (*.gif;*.jpg;*.jpeg;*.bmp;*.wmf;*.png)|*.gif;*.jpg;*.jpeg;*.bmp;*.wmf;*.png"
        If opn.ShowDialog = DialogResult.OK Then
            PictureBox1.ImageLocation = opn.FileName
            image_arr.Add(Image.FromFile(opn.FileName))
            image_file_name_arr.Add(opn.FileName)
        End If
    End Sub

    Private Sub ClearimageToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClearimageToolStripMenuItem.Click
        image_arr.Clear()
        image_file_name_arr.Clear()
        PictureBox1.Image = Nothing
        image_index_val = 0
        RaiseEvent Index(Me, image_index_val)
    End Sub

    Private Sub ToolStripTextBox1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles ToolStripTextBox1.KeyDown
        If IsNumeric(ToolStripTextBox1.Text) Then
            If ToolStripTextBox1.Text > 10 Then
                Timer1.Interval = ToolStripTextBox1.Text
            End If
        End If
    End Sub

    Private Sub StartToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartToolStripMenuItem.Click
        If StartToolStripMenuItem.Text = "Start" Then
            Timer1.Enabled = True
            StartToolStripMenuItem.Text = "Stop"
        Else
            Timer1.Enabled = False
            StartToolStripMenuItem.Text = "Start"
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If Me.Enabled Then
            If image_arr.Count - 2 >= image_index_val Then
                image_index_val += 1
            Else
                image_index_val = 0
            End If
            image_get_index()
            RaiseEvent Index(Me, image_index_val)
        End If
    End Sub
    Dim image_index_val As Integer
    Dim image_arr As New ArrayList
    Dim image_file_name_arr As New ArrayList
    Sub image_get_index()
        If image_index_val < 0 Then Exit Sub
        If image_arr.Count - 1 >= image_index_val Then
            PictureBox1.Image = image_arr(image_index_val)
        End If
    End Sub

    Private Sub SaveToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveToolStripMenuItem.Click
        Try
            Dim sv As New SaveFileDialog
            sv.Filter = "Xml files (*.xml)|*.xml"
            If sv.ShowDialog = DialogResult.OK Then
                FileOpen(1, sv.FileName, OpenMode.Output)
                PrintLine(1, Timer1.Interval)
                FileClose(1)
                Dim folder As String = Mid(sv.FileName, 1, sv.FileName.Length - 4)
                If Directory.Exists(folder) = False Then
                    MkDir(folder)
                End If
                Dim i As Integer
                For i = 0 To image_file_name_arr.Count - 1
                    If image_file_name_arr(i) <> folder & "\Pic_" & i & ".pic" Then
                        FileCopy(image_file_name_arr(i), folder & "\Pic_" & i & ".pic")
                    End If
                Next
            End If
        Catch ex As Exception
            MessageBox.Show(ex.ToString, ex.Message)
        End Try
    End Sub

    Private Sub LoadToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LoadToolStripMenuItem.Click
        Try
            Dim opn As New OpenFileDialog
            opn.Filter = "Xml files (*.xml)|*.xml"
            If opn.ShowDialog = DialogResult.OK Then
                Load_Settings(opn.FileName)
            End If
        Catch ex As Exception
            MessageBox.Show(ex.ToString, ex.Message)
        End Try
    End Sub

    Dim LastLoadPath As String
    Sub Load_Settings(ByVal opn As String)
        LastLoadPath = opn
        FileOpen(1, opn, OpenMode.Input)
        ToolStripTextBox1.Text = LineInput(1)
        FileClose()
        If IsNumeric(ToolStripTextBox1.Text) Then
            If ToolStripTextBox1.Text > 10 Then
                Timer1.Interval = ToolStripTextBox1.Text
            End If
        End If
        Dim folder As String = Mid(opn, 1, opn.Length - 4)
        PictureBox1.Image = Nothing
        image_arr.Clear()
        image_file_name_arr.Clear()
        For Each FileName As String In Directory.GetFiles(folder)
            image_arr.Add(Image.FromFile(FileName))
            image_file_name_arr.Add(FileName)
        Next
        If image_arr.Count > 0 Then PictureBox1.Image = image_arr(0)
    End Sub
End Class
